package proof

import proof.types.trees.BinaryTrees.{*, given}
import proof.types.formulas.*
import proof.types.formulas.ProofSystem.*

object InOrderMirrorProof extends InOrderMirrorTheorems:
  import InOrderMirror.*
  import Axioms.*
  import Variables.*
  import InductionHypotheses.*

  // Base Case
  val EmptyCase = Theorem(EmptyCaseStatement):
    Empty.mirror.inOrder
      === Empty.inOrder         ==< Mirror.EmptyCase
      === Nil                   ==< InOrder.EmptyCase
      === Nil.reverse           ==< Reverse.NilCase
      === Empty.inOrder.reverse ==< InOrder.EmptyCase

  // Inductive Case
  val NodeCase = Theorem(NodeCaseStatement):
    Node(left, x, right).inOrder.reverse
    ???

  @main def runTheorems =
    EmptyCase.verify
    NodeCase.verify
